library IEEE;
use IEEE.STD_LOGIC_1164.ALL, IEEE.NUMERIC_STD.ALL;

entity top_module is
port (  
        -- In
        Clk_125MHz : in std_logic;
       
        -- Out
        SDA : inout std_logic;
        SCL : out std_logic;
        led : out std_logic_vector(3 downto 0)
      );

end top_module;

architecture Behavioral of top_module is

    signal Clk_75MHz, Clk_12_288MHz, Clk_3_072MHz, Clk_500kHz, Clk_250kHz, Clk_48kHz : std_logic;
    signal SDA_1 : std_logic;
    signal data : std_logic_vector(11 downto 0);
    signal bitCounter : unsigned(4 downto 0);
	signal CHs : unsigned(1 downto 0);
	signal data_out_CH00 : std_logic_vector(11 downto 0);
    
begin

    ClockTree:      entity work.ClockTree   port map ( Clk_125MHz, Clk_75MHz, Clk_12_288MHz, Clk_3_072MHz, Clk_500kHz, Clk_250kHz, Clk_48kHz );
	
    i2c_out:        entity work.i2c_out 	port map (Clk_48kHz, SDA_1, SCL, bitCounter,CHs);
	i2c_z:          entity work.i2c_z 		port map (SDA_1, SDA);
	
    SDA_read:       entity work.SDA_read 	port map (SDA, SCL, bitCounter, data);
    CH_read:       entity work.CH_read 	    port map (data,CHs,SCL,data_out_CH00);  --generic map ( CH =>  "00") 
    
	led_out:        entity work.led_out 	port map (data_out_CH00, led);
	
end Behavioral;
